/**********************************************************************
  }V̊蓖ăR}h
  $Id: memal_cmd.c,v 1.6 2006/03/19 07:35:49 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int  memal_parse_opt(struct GETOPT_ARG *args) ;
void memal_print_help() ;

int memal_cmd( struct GETOPT_ARG *args, int mode )
{
  int   i ;
  int   seg ; 
  int   id ;
  int   res ;
  char *atrname[]={ "normal", "shared" } ;
  int   ret ;
  
  ret=memal_parse_opt(args) ;
  if( ret<0 ) return(NORMAL_EXIT) ;
  
  id=proc_list.cur_id ;
  
  if( XGETOPT_REFARGP(args,1)==NULL ){
    SYSMSG("---- Memory map of PID %d ---\n",id) ;
    for( i=0 ; i<MEM_SEGMENT_NUM ; i++ ){
      if( proc_list.proc[id].mem[i]!=NULL ){
	SYSMSG("%02x000000 : size=%08x , %s\n",
	       i,proc_list.proc[id].mem_size[i],
	       atrname[proc_list.proc[id].mem_attr[i]]) ;
      }else{
	//SYSMSG("%02x000000 : no allocate\n",i) ;
      }
    }
    return(NORMAL_EXIT) ;
  }
  
  if( XGETOPT_REFARGP(args,2)==NULL ) seg=0 ;
  else                                seg=exatoi(XGETOPT_REFARGP(args,2)) ;
  if( seg<0 || seg>=MEM_SEGMENT_NUM ) {
    SYSMSG("Specified invalid segment(range:0x00 to 0xff)\n") ;
    return(SPECIFY_ERROR) ;
  }
  
  i=exatoi(XGETOPT_REFARGP(args,1)) ;
  if( i>0 ){
    res=memal( &proc_list.proc[id], seg, i, MEM_ATTR_NORMAL ) ;
    if(       res==MEM_ALLOC_ERROR ){
      SYSMSG("Can not allocate memory(size=%d)\n", i ) ;
    }
    return( res ) ;
  }else{
    SYSMSG("Specified invalid memory size(range:0x00000001 to 0x01000000)\n") ;
    return(SPECIFY_ERROR) ;
  }
  
  return(NORMAL_EXIT) ;

}



int memal_parse_opt(struct GETOPT_ARG *args)
{
  static struct GETOPT_LIST getopt_list[]={
    {"help",               'h',  NONARG, 'h'},
    { NULL,               '\0',       0,'\0'} /*** terminator ***/
  } ;
  int ret ;
  
  while(-1){
    ret=xgetopt(args, getopt_list) ;
    if( ret==XGETOPT_PARSE_COMPLETE ) break ;
    switch(ret){
    case 'h' :
      memal_print_help() ;
      return(-1) ;
      break ;
    case XGETOPT_INVALID_OPTION :
      SYSERR("Invalid option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_ARG_NOT_FOUND :
      SYSERR("Illegal arg for option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_NOT_OPTION :
      break ;
    default :
      SYSERR("xgetopt internal error\n") ;
      return(-1) ;
    }
  }
  return(0) ;
}


void memal_print_help()
{
  SYSERR(
	 "Allocate simulation memory\n"
	 "Usage: memal [options] [size [seg]]\n"
	 "  size : 0x00000001 to 0x01000000\n"
	 "  seg  : 0x00 to 0xff\n"
	 " Options\n"
	 "  -h or --help : Print this help.\n"
	 "\n"
	 "     JgvZX̎wZOgTCYύX܂BύXÕ\n"
	 "    ̓e͈p܂B\n"
	 "     ZOg0x00`0xFF܂ł͈̔͂Ŏw肵܂B̃ZOg͍ő16MB\n"
	 "    ܂Ŋ蓖Ă邱Ƃł܂Bȗ0x00w肳ꂽ̂Ƃ܂B\n"
	 "    ZOgTCY傫ȃTCYw肵͘AZOg\n"
	 "    Ɋ蓖ĂȂw肵TCY̊蓖Ăs܂B\n"
	 "     ȗƁÃ݂蓖ď󋵂\\܂B\n"
	 ) ;
}

/*********************************************************************
  
  020622
  ZOgTCY256MBł̓TCY傫߂MPC106̃}bsO
  0xff______犄ROMԂ̊蓖ĂłȂ߁AZOg
  TCY16MB܂ŏk(ZOg=256)B
  ܂A蓖Ăsp֐memal():memal.cpӂA
  gpă蓖ĂslɎdlύXB
*********************************************************************/
