/**********************************************************************
  VXeR[G~[V
   for newlib based Standard C library and
       glibc2.2.2/glibc2.3.6 based Standard C library
  $Id: op_scemu.c,v 1.9 2006/03/19 07:35:52 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"
#include "op_scemu.h"
#include <sys/time.h>
#include <sys/times.h>
#include <sys/ioctl.h>
#include <termio.h>

#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
#define SWAP2B(a)  {char t;t=((char*)&a)[0];((char*)&a)[0]=((char*)&a)[1];((char*)&a)[1]=t;}
#define SWAP4B(a)  {char t;t=((char*)&a)[0];((char*)&a)[0]=((char*)&a)[3];((char*)&a)[3]=t;\
                           t=((char*)&a)[1];((char*)&a)[1]=((char*)&a)[2];((char*)&a)[2]=t;}
#define SWAP8B(a)  {char t;t=((char*)&a)[0];((char*)&a)[0]=((char*)&a)[7];((char*)&a)[7]=t;\
                           t=((char*)&a)[1];((char*)&a)[1]=((char*)&a)[6];((char*)&a)[6]=t;\
                           t=((char*)&a)[2];((char*)&a)[2]=((char*)&a)[5];((char*)&a)[5]=t;\
                           t=((char*)&a)[3];((char*)&a)[3]=((char*)&a)[4];((char*)&a)[4]=t;}
#else
#define SWAP2B(a)
#define SWAP4B(a)
#define SWAP8B(a)
#endif

void stat_cpyto32( struct stat *st , struct MACHINE_RESOURCE *mres, unsigned int adrs ) ;
void stat_cpyto64( struct stat *st , struct MACHINE_RESOURCE *mres, unsigned int adrs ) ;
void dirent_cpyto64( struct stat *st , struct MACHINE_RESOURCE *mres, unsigned int adrs ) ;

void open_mode_exchg(int *mode1 , int *mode2 , struct MACHINE_RESOURCE *mres ) ;
void stat_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void DIR_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void dirent_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void set_DIR_entry( unsigned int adrs , DIR *dirpt ) ;
void remove_DIR_entry( unsigned int adrs ) ;
DIR* search_DIR_entry( unsigned int adrs ) ;
void timbuf_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void tm_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void timeval_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void timezone_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;

struct Linux_dirent {
  long long d_ino;
  long long d_off;
  unsigned short d_reclen;
  unsigned char d_type;
  char d_name[256];
} ;

struct Linux_winsize {
  unsigned short ws_row;
  unsigned short ws_col;
  unsigned short ws_xpixel;
  unsigned short ws_ypixel;
};

#define Linux_NCC 10
struct Linux_termio {
  unsigned short c_iflag;         /* input mode flags */
  unsigned short c_oflag;         /* output mode flags */
  unsigned short c_cflag;         /* control mode flags */
  unsigned short c_lflag;         /* local mode flags */
  unsigned char c_line;           /* line discipline */
  char          c_cc[Linux_NCC];        /* control characters */
};

struct fd_info{
  int flag ; /** openning /closing **/
  char *name ;
  struct Linux_dirent *dir ;
  int cur ; /** 0:top ..../ -1:end of entry **/
  int dent_blen ;
  int dent_ptr ;
} ;

struct fd_info fdinfo[256] ;

int	op_scemu( struct MACHINE_RESOURCE *mres )
{
#ifdef SUPPORT_SYSTEMCALL_EMULATION
int	   ret ;

 if( truss_stat==ON ) SYSMSG("%08x:Syscall_NO=%d\n  ",mres->pc,mres->GPR[0].rl) ;
 switch( mres->GPR[0].rl ){
   int mode1,mode2 ;
   int size ;
 case 1: // exit()
   if( truss_stat==ON ) SYSMSG("exit(%x)\n",mres->GPR[3].rl) ;
   return(SYSCALLED_EXIT) ;
 case 2: // fork()
   if( truss_stat==ON ) SYSMSG("fork()\n") ;
   mres->pc+=4 ;
   return(SYSCALLED_FORK) ;
 case 3 : // read()
   ChkMemRange(mres,(mres->GPR[4].rl+mres->GPR[5].rl-1),ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("read(%08x,%08x,%08x)",
	    get_phyfd(mres,(int)mres->GPR[3].rl),
	    //mres->GPR[3].rl,
	    mres->GPR[4].rl,
	    mres->GPR[5].rl) ;
   }
   ret = read( get_phyfd(mres,(int)mres->GPR[3].rl),
	       &mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)],
	       (int)mres->GPR[5].rl ) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ){ SYSMSG("===>%08x\n",ret ); }
   mres->pc+=4 ; return(0) ;
 case 4 : // write()
   ChkMemRange(mres,(mres->GPR[4].rl+mres->GPR[5].rl-1),ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("write(%08x,%08x,%08x)",
	    mres->GPR[3].rl,mres->GPR[4].rl,mres->GPR[5].rl) ;
   }
   ret = write( get_phyfd(mres,(int)mres->GPR[3].rl),
		&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)],
		(int)mres->GPR[5].rl ) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ){ SYSMSG("===>%08x\n",ret ); }
   mres->pc+=4 ; return(0) ;
 case 5: // open()
   ChkMemStr(mres,mres->GPR[3].rl,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   open_mode_exchg( &mode1 , &mode2 , mres ) ;
   if( truss_stat==ON ){
     SYSMSG("open(\"%s\",%08x,%08x)",
	    &mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],mode1,mode2) ;
   }
   ret = open( (char*)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)], mode1, mode2) ;
   if( ret>=0 ){
     fdinfo[ret].flag=1 ;
     fdinfo[ret].name=malloc(strlen((char*)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)])+1) ;
     if( fdinfo[ret].name==NULL ) return(MEM_ALLOC_ERROR) ;
     strcpy(fdinfo[ret].name,(char*)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)]) ;
     fdinfo[ret].dir      =NULL ;
     fdinfo[ret].dent_blen=0 ;
   }
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = set_phyfd(mres,ret) ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",mres->GPR[3].rl) ;
   mres->pc+=4 ; return(0) ;
 case 6: // close()
   if( truss_stat==ON ) SYSMSG("close(%08x)\n",mres->GPR[3].rl) ;
   ret = close_fd( mres, (int)mres->GPR[3].rl );
   fdinfo[(int)mres->GPR[3].rl].flag=0 ;
   free(fdinfo[(int)mres->GPR[3].rl].name) ;
   if( fdinfo[(int)mres->GPR[3].rl].dir!=NULL ){
     free(fdinfo[(int)mres->GPR[3].rl].dir) ;
   }
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   mres->pc+=4 ; return(0) ;
 case 10: // unlink()
   if( truss_stat==ON ){
     SYSMSG("unlink(\"%s\") not implement yet.\n",
	    (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)]) ;
   }
   ret=0 ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   mres->pc+=4 ; return(0) ;
 case 11: // execve()
   ChkMemStr(mres,mres->GPR[3].rl,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("execve(\"%s\",%08x,%08x,%08x)\n",
	    (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	    mres->GPR[4].rl,
	    mres->GPR[5].rl,
	    mres->GPR[6].rl ) ;
   }
   mres->pc+=4 ;
   return(SYSCALLED_EXECVE) ;
 case 12: // chdir()
   ChkMemStr(mres,mres->GPR[3].rl,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ) SYSMSG("chdir(\"%s\")\n",(char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)]) ;
   ret = chdir( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   mres->pc+=4 ; return(0) ;
 case 13: // time()
   ChkMemRange(mres,(mres->GPR[3].rl+4-1),ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ) SYSMSG("time(%08x)",mres->GPR[3].rl) ;
   {
     ret = time( (time_t *) 0 ) ;
     if( mres->GPR[3].rl != 0 ){
       unsigned char *ptr=&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ;
       ptr[0]=(ret & 0xff000000)>>24 ;
       ptr[1]=(ret & 0x00ff0000)>>16 ;
       ptr[2]=(ret & 0x0000ff00)>> 8 ;
       ptr[3]=(ret & 0x000000ff)     ;
     }
     if( ret<0 ){
       mres->GPR[3].rl = errno ;
       mres->FLGR.cr[0] |= 0x10000000 ;
     }else{
       mres->GPR[3].rl = ret ;
       mres->FLGR.cr[0] &= ~0x10000000 ;
     }
     if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   }
   mres->pc+=4 ; return(0) ;
 case 15: // chmod()
   ChkMemStr(mres,mres->GPR[3].rl,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("chmod(\"%s\",%08x)",
	    (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	    mres->GPR[4].rl ) ;
   }
   ret = chmod( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		mres->GPR[4].rl ) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 19: // lseek()
   if( truss_stat==ON ){
     SYSMSG("lseek(%08x,%08x,%08x)",
	    mres->GPR[3].rl, mres->GPR[4].rl,mres->GPR[5].rl ) ;
   }
   ret = lseek( get_phyfd(mres,(int)mres->GPR[3].rl),
		(off_t)((int)mres->GPR[4].rl),
		(int)mres->GPR[5].rl ) ;
   mres->GPR[3].rl = ret ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 20: // getpid() for linux ELF
   if( truss_stat==ON ){
     SYSMSG("getpid(%08x,%08x,%08x)",
	    mres->GPR[3].rl, mres->GPR[4].rl,mres->GPR[5].rl ) ;
   }
   ret=mres->id ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 24: // getuid() for linux ELF
   if( truss_stat==ON ) SYSMSG("getuid()") ;
   ret=500 ; // hard cording
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 30: // utime()
   ChkMemStr(mres,mres->GPR[3].rl,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   ChkMemRange(mres,(mres->GPR[4].rl+sizeof(struct utimbuf)-1),ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("utime(\"%s\",%08x)",
	    (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	    mres->GPR[4].rl ) ;
   }
   timbuf_exchg( mres, mres->GPR[4].rl ) ;
   ret = utime( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		(struct utimbuf *)&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)] ) ;
   timbuf_exchg( mres, mres->GPR[4].rl ) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 33: // access()
   ChkMemStr(mres,mres->GPR[3].rl,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("access(\"%s\",%08x)",
	    (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	    mres->GPR[4].rl ) ;
   }
   ret = access( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		 mres->GPR[4].rl ) ;
   if( mres->GPR[4].rl==0x00000001 ) ret=0 ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 38: // rename()
   ChkMemStr(mres,mres->GPR[3].rl,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   ChkMemStr(mres,mres->GPR[4].rl,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("rename(\"%s\",\"%s\")",
	    (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	    (char *)&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)]) ;
   }
   ret = rename( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		 (char *)&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)] ) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 39: // mkdir()
   ChkMemStr(mres,mres->GPR[3].rl,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("mkdir (\"%s\",%08x)",
	    (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	    mres->GPR[4].rl ) ;
   }
   ret = mkdir( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],mres->GPR[4].rl) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 41: // dup()
   if( truss_stat==ON ) SYSMSG("dup(%08x)",(int)mres->GPR[3].rl) ;
   ret=dup(get_phyfd(mres,mres->GPR[3].rl)) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = set_phyfd(mres,ret) ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",mres->GPR[3].rl) ;
   mres->pc+=4 ; return(0) ;
 case 43: // times()
   ChkMemRange(mres,(mres->GPR[3].rl+sizeof(struct tms *)-1),ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ) SYSMSG("times(%08x)",(int)mres->GPR[3].rl) ;
   tm_exchg( mres, mres->GPR[3].rl ) ;
   ret = times( (struct tms *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ) ;
   tm_exchg( mres, mres->GPR[3].rl ) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 45: // brk() for linux ELF
   if( truss_stat==ON ) SYSMSG("brk(%08x)",(int)mres->GPR[3].rl) ;
   {
     int adrs ;
     adrs=(int)mres->GPR[3].rl ;
     if( adrs==0 ){
       mres->GPR[3].rl = mres->brk_top ;
       mres->FLGR.cr[0] &= ~0x10000000 ;
     }else{
       if( adrs<mres->brk_top ||
	   adrs>mres->brk_top+mres->brk_size ){
	 mres->GPR[3].rl = 12 ; /** ENOMEM **/
	 mres->FLGR.cr[0] |= 0x10000000 ;
       }else{
	 mres->brk_cur=adrs ;
	 mres->FLGR.cr[0] &= ~0x10000000 ;
       }
     }
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",(int)mres->GPR[3].rl) ;
   mres->pc+=4 ; return(0) ;
 case 47: // getgid() for linux ELF
   if( truss_stat==ON ) SYSMSG("getgid(%08x)\n",(int)mres->GPR[3].rl) ;
   ret = 544 ; // hard cording
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   mres->pc+=4 ; return(0) ;
 case 49: // geteuid() for linux ELF
   if( truss_stat==ON ) SYSMSG("geteuid(%08x)\n",(int)mres->GPR[3].rl) ;
   ret = 500 ; // hard cording
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   mres->pc+=4 ; return(0) ;
 case 50: // getegid() for linux ELF
   if( truss_stat==ON ) SYSMSG("getegid(%08x)\n",(int)mres->GPR[3].rl) ;
   ret = 544 ; // hard cording
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   mres->pc+=4 ; return(0) ;
 case 54: // ioctl()
   ChkMemStr(mres,mres->GPR[5].rl,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("ioctl(%08x,%08x,%08x,%08x)",
	    mres->GPR[3].rl,mres->GPR[4].rl,
	    mres->GPR[5].rl,mres->GPR[6].rl) ;
   }
   ret=0 ;
   if( ((mres->GPR[4].rl & 0x0000ff00)>>8)=='t' ){
     if( (mres->GPR[4].rl & 0x000000ff)==104 ){ //TIOCGWINSZ
       struct Linux_winsize *linux_ws ;
       struct winsize host_ws ;

       ioctl(mres->GPR[3].rl,TIOCGWINSZ,&host_ws) ;
       linux_ws=(struct Linux_winsize *)&mres->mem[seg(mres->GPR[5].rl)][lad(mres->GPR[5].rl)] ;
       linux_ws->ws_row=host_ws.ws_row ; SWAP2B(linux_ws->ws_row) ;
       linux_ws->ws_col=host_ws.ws_col ; SWAP2B(linux_ws->ws_col) ;
       ret=0 ;
       if( truss_stat==ON ) SYSMSG("===>%08x TIOCGWINSZ",ret) ;
     }
     if( (mres->GPR[4].rl & 0x000000ff)==19 ){ //TCGETS
       ret=isatty(mres->GPR[3].rl) ;
       if( ret==1 ) ret=0 ;
       else         ret=1 ;
       if( truss_stat==ON ) SYSMSG("===>%08x TCGETS",ret) ;
     }
   }
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("\n") ;
   mres->pc+=4 ; return(0) ;
 case 55: // fcntl()
   if( truss_stat==ON ){
     SYSMSG("fcntl(=%08x,%08x,%08x)",
	    mres->GPR[3].rl,mres->GPR[4].rl,mres->GPR[5].rl) ;
   }
   ret = fcntl( get_phyfd(mres,(int)mres->GPR[3].rl),
		(int)mres->GPR[4].rl,
		(int)mres->GPR[5].rl ) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 60: // umask()
   if( truss_stat==ON ){
     SYSMSG("umask(%08x)",mres->GPR[3].rl) ;
   }
   ret=umask(mres->GPR[3].rl) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 63: // dup2()
   if( truss_stat==ON ){
     SYSMSG("dup2(%08x,%08x)",
	    (int)mres->GPR[3].rl,
	    (int)mres->GPR[4].rl) ;
   }
   ret=dup(get_phyfd(mres,mres->GPR[3].rl)) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = set_phyfd2(mres,mres->GPR[4].rl,ret) ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",mres->GPR[3].rl) ;
   mres->pc+=4 ; return(0) ;
 case 64: // getppid()
   if( truss_stat==ON ){
     SYSMSG("getppid()") ;
   }
   ret=mres->id - 1 ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 65: // getpgrp()
   if( truss_stat==ON ){
     SYSMSG("getpgrp()") ;
   }
   ret=getpgrp() ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 77: // getrusage() for linux ELF
   if( truss_stat==ON ) SYSMSG("getrusage(%08x,%08x)\n",
				(int)mres->GPR[3].rl,(int)mres->GPR[4].rl) ;
   ret = 0 ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   mres->pc+=4 ; return(0) ;
 case 78: // gettimeofday()
   ChkMemRange(mres,mres->GPR[3].rl+sizeof(struct timeval)-1,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   ChkMemRange(mres,mres->GPR[4].rl+sizeof(struct timezone)-1,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ) SYSMSG("gettimeofday(%08x,%08x)\n",
				(int)mres->GPR[3].rl,(int)mres->GPR[4].rl) ;
   timeval_exchg(  mres, mres->GPR[3].rl ) ;
   timezone_exchg( mres, mres->GPR[4].rl ) ;
   ret = gettimeofday( (struct timeval  *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		       (struct timezone *)&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)] ) ;
   timeval_exchg(  mres, mres->GPR[3].rl ) ;
   timezone_exchg( mres, mres->GPR[4].rl ) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   mres->pc+=4 ; return(0) ;
 case 85: // readlink()
   ChkMemStr(mres,mres->GPR[3].rl,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("readlink(\"%s\",%08x,%08x)",
	    &mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	    mres->GPR[4].rl,mres->GPR[5].rl) ;
   }
   ret=readlink((char*)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		(char*)&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)],
		mres->GPR[5].rl) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 89: // readdir()
   if( sc_emu_mode==LINUXPPC ){
     return(UNKNOWN_SYSCALL_NO) ;
   }else{
     if( truss_stat==ON ){
       SYSMSG("readdir(%08x)\n", mres->GPR[3].rl ) ;
     }
     {
       struct dirent *dp ;
       DIR_exchg( mres, mres->GPR[3].rl ) ;
       dp = readdir( (DIR *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ) ;
       DIR_exchg( mres, mres->GPR[3].rl ) ;
       if( dp==NULL ) mres->GPR[3].rl=0 ;
       else{
	 mres->GPR[3].rl=mres->GPR[4].rl ; /** dpԂ **/
	 dirent_exchg( mres, mres->GPR[4].rl ) ;
	 memcpy( &mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)], dp, sizeof(struct dirent) ) ;
	 dirent_exchg( mres, mres->GPR[4].rl ) ;
       }
     }
     mres->GPR[0].rl = errno ;
   }
   mres->pc+=4 ; return(0) ;
 case 90: // mmap() for linux ELF
   if( truss_stat==ON ){
     SYSMSG("mmap(%08x,%08x,%08x,%08x,%08x,%08x)",
	    mres->GPR[3].rl,mres->GPR[4].rl,mres->GPR[5].rl,
	    mres->GPR[6].rl,mres->GPR[7].rl,mres->GPR[8].rl) ;
   }
   ret = sim_mmap( mres,
		   mres->GPR[3].rl,    //_addr
		   mres->GPR[4].rl,    //_len
		   mres->GPR[5].rl,    //_prot
		   mres->GPR[6].rl,    //_flags
		   mres->GPR[7].rl,    //_fd
		   mres->GPR[8].rl ) ; //_off
   if( truss_stat==ON ) SYSMSG("===>%08x\n",(int)ret) ;
   if( ret==0xffffffff ){
     mres->GPR[3].rl = 12 ; /** ENOMEM **/
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   mres->pc+=4 ; return(0) ;
 case 91: // munmap() for linux ELF
   if( truss_stat==ON ) SYSMSG("munmap(%08x,%08x)\n",mres->GPR[3].rl,mres->GPR[4].rl) ;
   ret = sim_munmap( mres,
		     mres->GPR[3].rl,    //_addr
		     mres->GPR[4].rl ) ; //_len
   if( ret<0 ){
     mres->GPR[3].rl = EINVAL ; /* Invalid argument */
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   mres->pc+=4 ; return(0) ;
 case 106: // stat()
   ChkMemStr(mres,mres->GPR[3].rl,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("stat(\"%s\",%08x)",&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	                        mres->GPR[4].rl) ;
   }
   {
     struct stat stat_tmp ;
     ret = stat( (char*)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)], &stat_tmp ) ;
     stat_cpyto32( &stat_tmp, mres, mres->GPR[4].rl ) ;
     if( ret<0 ){
       mres->GPR[3].rl = errno ;
       mres->FLGR.cr[0] |= 0x10000000 ;
     }else{
       mres->GPR[3].rl = ret ;
       mres->FLGR.cr[0] &= ~0x10000000 ;
     }
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 107: // lstat()
   ChkMemStr(mres,mres->GPR[3].rl,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   ChkMemRange(mres,mres->GPR[4].rl+64-1,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("lstat(\"%s\",%08x)",
	    &mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],mres->GPR[4].rl) ;
   }
   {
     struct stat stat_tmp ;
     ret = lstat( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)], &stat_tmp ) ;
     stat_cpyto32( &stat_tmp, mres, mres->GPR[4].rl ) ;
     if( ret<0 ){
       mres->GPR[3].rl = errno ;
       mres->FLGR.cr[0] |= 0x10000000 ;
     }else{
       mres->GPR[3].rl = ret ;
       mres->FLGR.cr[0] &= ~0x10000000 ;
     }
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",mres->GPR[3].rl) ;
   mres->pc+=4 ; return(0) ;
 case 108: // fstat()
   if( truss_stat==ON ) SYSMSG("fstat(%08x,%08x)",mres->GPR[3].rl,mres->GPR[4].rl) ;
   {
     struct stat stat_tmp ;
     ret = fstat( get_phyfd(mres,(int)mres->GPR[3].rl), &stat_tmp ) ;
     stat_cpyto32( &stat_tmp, mres, mres->GPR[4].rl ) ;
     if( ret<0 ){
       mres->GPR[3].rl = errno ;
       mres->FLGR.cr[0] |= 0x10000000 ;
     }else{
       mres->GPR[3].rl = ret ;
       mres->FLGR.cr[0] &= ~0x10000000 ;
     }
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",mres->GPR[3].rl) ;
   mres->pc+=4 ; return(0) ;
 case 114: // wait4()
   if( truss_stat==ON ){
     SYSMSG("wait4(%08x,%08x,%08x)",
	    mres->GPR[3].rl,
	    *(int *)(&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)]),
	    mres->GPR[5].rl) ;
   }
   {
     *(int*)(&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)])=0 ;
     ret=mres->id ;
     if( ret<0 ){
       mres->GPR[3].rl = errno ;
       mres->FLGR.cr[0] |= 0x10000000 ;
     }else{
       mres->GPR[3].rl = ret ;
       mres->FLGR.cr[0] &= ~0x10000000 ;
     }
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",mres->GPR[3].rl) ;
   mres->pc+=4 ; return(0) ;
 case 122: // uname()
   ChkMemRange(mres,mres->GPR[3].rl+260-1,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ) SYSMSG("uname(%08x)\n",mres->GPR[3].rl) ;
   { // for struct old_utsname
     // always success.
     char *ptr ;

     ptr=(char*)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ;
     strcpy( ptr, "ppcsim" ) ; ptr+=65 ; // sysname[65]
     strcpy( ptr, "none"   ) ; ptr+=65 ; // nodename[65]
     strcpy( ptr, "92"     ) ; ptr+=65 ; // release[65]
     strcpy( ptr, "0"      ) ; ptr+=65 ; // version[65]
     strcpy( ptr, "ppcsim" ) ; ptr+=65 ; // machine[65]
     //strcpy( ptr, "none"   ) ;           // domainname[65]
     ret=0 ;
     if( ret<0 ){
       mres->GPR[3].rl = errno ;
       mres->FLGR.cr[0] |= 0x10000000 ;
     }else{
       mres->GPR[3].rl = ret ;
       mres->FLGR.cr[0] &= ~0x10000000 ;
     }
   }
   mres->pc+=4 ; return(0) ;
 case 125: // _mprotect() for linux ELF
   if( truss_stat==ON ) SYSMSG("mprotect()\n") ;
   ret=0 ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   mres->pc+=4 ; return(0) ;
 case 133: // fchdir()
   if( truss_stat==ON ) SYSMSG("fchdir(%08x)\n",mres->GPR[3].rl) ;
   ret=fchdir( get_phyfd(mres,(int)mres->GPR[3].rl) ) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",mres->GPR[3].rl) ;
   mres->pc+=4 ; return(0) ;
 case 140: // llseek() for linux ELF
   ChkMemRange(mres,(mres->GPR[6].rl+8-1),ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("llseek(%08x,%08x,%08x,%08x,%08x)",
	    mres->GPR[3].rl,mres->GPR[4].rl,mres->GPR[5].rl,mres->GPR[6].rl,mres->GPR[7].rl ) ;
   }
   ret = lseek( get_phyfd(mres,(int)mres->GPR[3].rl),
		(off_t)((int)mres->GPR[5].rl),
		(int)mres->GPR[7].rl ) ;
   mres->GPR[0].rl = errno ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = 0 ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
     {
       unsigned char *ptr=&mres->mem[seg(mres->GPR[6].rl)][lad(mres->GPR[6].rl)] ;
       ptr[0]=0 ; ptr[1]=0 ; ptr[2]=0 ; ptr[3]=0 ;
       ptr[4]=(ret & 0xff000000)>>24 ;
       ptr[5]=(ret & 0x00ff0000)>>16 ;
       ptr[6]=(ret & 0x0000ff00)>> 8 ;
       ptr[7]=(ret & 0x000000ff)     ;
     }
   }
   if( truss_stat==ON ){
     SYSMSG("===>%08x\n",mres->GPR[3].rl ) ;
   }
   mres->pc+=4 ; return(0) ;
 case 173: // rt_sigaction()
   if( truss_stat==ON ) SYSMSG("rt_sigaction(%08x,%08x)\n",mres->GPR[3].rl,mres->GPR[4].rl) ;
   {
     // always true.
     ret=0 ;
     if( ret<0 ){
       mres->GPR[3].rl = EINVAL ;
       mres->FLGR.cr[0] |= 0x10000000 ;
     }else{
       mres->GPR[3].rl = ret ;
       mres->FLGR.cr[0] &= ~0x10000000 ;
     }
   }
   mres->pc+=4 ; return(0) ;
 case 174: // rt_sigprocmask()
   if( truss_stat==ON ) SYSMSG("rt_sigprocmask()\n") ;
   {
     // always success.
     ret=0 ;
     if( ret<0 ){
       mres->GPR[3].rl = EINVAL ;
       mres->FLGR.cr[0] |= 0x10000000 ;
     }else{
       mres->GPR[3].rl = ret ;
       mres->FLGR.cr[0] &= ~0x10000000 ;
     }
   }
   mres->pc+=4 ; return(0) ;
 case 181: // chown()
   ChkMemStr(mres,mres->GPR[3].rl,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("chown(\"%s\",%08x,%08x)\n",
	    (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	    mres->GPR[4].rl,
	    mres->GPR[5].rl ) ;
   }
   ret = chown( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		(uid_t)mres->GPR[4].rl,
		(gid_t)mres->GPR[5].rl ) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   mres->pc+=4 ; return(0) ;
 case 182: // getcwd()
   ChkMemRange(mres,mres->GPR[3].rl+mres->GPR[4].rl-1,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("getcwd(%08x,%08x)",
	    mres->GPR[3].rl,
	    mres->GPR[4].rl) ;
   }
   ret = (unsigned int)getcwd( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
			       (int)mres->GPR[4].rl ) ;
   if( ret!=(unsigned int)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",mres->GPR[3].rl) ;
   mres->pc+=4 ; return(0) ;
 case 190: // ugetrlimit()
   ChkMemRange(mres,mres->GPR[3].rl+mres->GPR[4].rl-1,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("ugetrlimit(%08x,%08x)",
	    mres->GPR[3].rl,
	    mres->GPR[4].rl) ;
   }
   ret=0 ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",mres->GPR[3].rl) ;
   mres->pc+=4 ; return(0) ;
 case 195: // stat64()
   ChkMemStr(mres,mres->GPR[3].rl,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("stat64(\"%s\",%08x)",
	    &mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	    mres->GPR[4].rl) ;
   }
   {
     struct stat stat_tmp ;
     ret = stat( (char*)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)], &stat_tmp ) ;
     stat_cpyto64( &stat_tmp, mres, mres->GPR[4].rl ) ;
     if( ret<0 ){
       mres->GPR[3].rl = errno ;
       mres->FLGR.cr[0] |= 0x10000000 ;
     }else{
       mres->GPR[3].rl = ret ;
       mres->FLGR.cr[0] &= ~0x10000000 ;
     }
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",mres->GPR[3].rl) ;
   mres->pc+=4 ; return(0) ;
 case 196: // lstat64()
   ChkMemStr(mres,mres->GPR[3].rl,ret) ;
   if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
   if( truss_stat==ON ){
     SYSMSG("lstat64(\"%s\",%08x)",
	    &mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	    mres->GPR[4].rl) ;
   }
   {
     struct stat stat_tmp ;
     ret = lstat( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)], &stat_tmp ) ;
     stat_cpyto64( &stat_tmp, mres, mres->GPR[4].rl ) ;
     if( ret<0 ){
       mres->GPR[3].rl = errno ;
       mres->FLGR.cr[0] |= 0x10000000 ;
     }else{
       mres->GPR[3].rl = ret ;
       mres->FLGR.cr[0] &= ~0x10000000 ;
     }
   }
   if( truss_stat==ON ) SYSMSG("===>%08x eno=%d\n",mres->GPR[3].rl,errno) ;
   mres->pc+=4 ; return(0) ;
 case 197: // fstat64()
   if( truss_stat==ON ) SYSMSG("fstat64(%08x,%08x)",mres->GPR[3].rl,mres->GPR[4].rl) ;
   {
     struct stat stat_tmp ;
     ret = fstat( get_phyfd(mres,(int)mres->GPR[3].rl), &stat_tmp ) ;
     stat_cpyto64( &stat_tmp, mres, mres->GPR[4].rl ) ;
     if( ret<0 ){
       mres->GPR[3].rl = errno ;
       mres->FLGR.cr[0] |= 0x10000000 ;
     }else{
       mres->GPR[3].rl = ret ;
       mres->FLGR.cr[0] &= ~0x10000000 ;
     }
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",mres->GPR[3].rl) ;
   mres->pc+=4 ; return(0) ;
 case 200: // isatty()
   if( sc_emu_mode==LINUXPPC ){
     return(UNKNOWN_SYSCALL_NO) ;
   }else{
     if( truss_stat==ON ) SYSMSG("isatty(%08x)\n",mres->GPR[3].rl) ;
     ret = isatty( get_phyfd(mres,(int)mres->GPR[3].rl) ) ;
     mres->GPR[3].rl = ret ;
     mres->GPR[0].rl = errno ;
     mres->pc+=4 ; return(0) ;
   }
 case 202: // sbrk() | getdents64()
   if( sc_emu_mode==LINUXPPC ){
     int fd ;

     if( truss_stat==ON ){
       SYSMSG("getdents64(%08x,%08x,%08x)",
	      mres->GPR[3].rl,mres->GPR[4].rl,mres->GPR[5].rl) ;
     }
     fd=get_phyfd(mres,mres->GPR[3].rl) ;
     if( fdinfo[fd].flag==1 ){
       if( fdinfo[fd].dent_blen==0 ){
	 DIR *dp ;
	 struct dirent *dir ;
	 int i ;
	 dp=opendir(fdinfo[fd].name) ;
	 fdinfo[fd].cur=0 ;
	 fdinfo[fd].dir=malloc(sizeof(struct Linux_dirent)*4096) ;
	 for( i=0 ; i<4096 ; i++ ){
	   dir=readdir(dp) ;
	   if( dir==NULL ) break ;
	   //SYSMSG("%s\n",dir->d_name) ;
	   fdinfo[fd].dir[i].d_ino=1 ; //dir->d_ino ; //can not use cygwin-1.5.19 sys/dirent.h
	   SWAP8B(fdinfo[fd].dir[i].d_ino) ;
	   strcpy(fdinfo[fd].dir[i].d_name,dir->d_name) ;
	   fdinfo[fd].dir[i].d_reclen=sizeof(struct Linux_dirent) ;
	   SWAP2B(fdinfo[fd].dir[i].d_reclen) ;
	 }
	 fdinfo[fd].dent_blen=sizeof(struct Linux_dirent)*i ;
	 fdinfo[fd].dent_ptr=0 ;
	 fdinfo[fd].cur     =0 ;
       }
       if( fdinfo[fd].dent_ptr < fdinfo[fd].dent_blen ){
	 unsigned char *src ;
	 unsigned char *dst ;
	 int ad=mres->GPR[4].rl ;
	 int i,n ;
	 
	 src=(unsigned char *)&fdinfo[fd].dir[fdinfo[fd].cur] ;
	 dst=&mres->mem[seg(ad)][lad(ad)] ;

	 if( mres->GPR[5].rl>(fdinfo[fd].dent_blen - fdinfo[fd].dent_ptr) ){
	   n=(fdinfo[fd].dent_blen - fdinfo[fd].dent_ptr) / sizeof(struct Linux_dirent) ;
	 }else{
	   n=mres->GPR[5].rl / sizeof(struct Linux_dirent) ;
	 }
	 for( i=0 ; i<(n*sizeof(struct Linux_dirent)) ; i++ ){
	   dst[i]=src[i] ;
	 }
	 fdinfo[fd].dent_ptr+=n*sizeof(struct Linux_dirent) ;
	 fdinfo[fd].cur+=n ;
	 mres->GPR[3].rl=n*sizeof(struct Linux_dirent) ;
       }else{
	 mres->GPR[3].rl=0 ;
       }
       if( truss_stat==ON ) SYSMSG("===>%08x\n",mres->GPR[3].rl) ;
     }
     mres->pc+=4 ; return(0) ;
   }else{
     if( truss_stat==ON ) SYSMSG("sbrk=(%08x)\n",mres->GPR[3].rl) ;
     size=(int)mres->GPR[3].rl ;
     if( (size%8)!=0 ) size=((size/8)+1)*8 ; // alignment 8byte boundary
     if( ( (mres->heap_cur+size) >= mres->heap_size) ||
	 ( (mres->heap_cur+size) < 0 ) ){
       mres->GPR[3].rl = 0xffffffff ;
       mres->GPR[0].rl = 12 ; /** ENOMEM **/
     }else{
       mres->GPR[3].rl = mres->heap_top+mres->heap_cur ;
       mres->heap_cur+= size ;
     }
   }
   mres->pc+=4 ; return(0) ;
 case 203: // pathconf()
   if( sc_emu_mode==LINUXPPC ){
     return(UNKNOWN_SYSCALL_NO) ;
   }else{
     ChkMemStr(mres,mres->GPR[3].rl,ret) ;
     if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
     if( truss_stat==ON ){
       SYSMSG("pathconf(%08x,%08x)\n",
	      mres->GPR[3].rl,mres->GPR[4].rl) ;
     }
     ret = pathconf( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		     (int)mres->GPR[4].rl ) ;
     mres->GPR[3].rl = ret ;
     mres->GPR[0].rl = errno ;
     mres->pc+=4 ; return(0) ;
   }
 case 204: // fcntl64()
   if( truss_stat==ON ){
     SYSMSG("fcntl64(%08x,%08x,%08x)",
	    mres->GPR[3].rl,mres->GPR[4].rl,mres->GPR[5].rl) ;
   }
   ret = fcntl( get_phyfd(mres,(int)mres->GPR[3].rl),
		(int)mres->GPR[4].rl,
		(int)mres->GPR[5].rl ) ;
   if( ret<0 ){
     mres->GPR[3].rl = errno ;
     mres->FLGR.cr[0] |= 0x10000000 ;
   }else{
     mres->GPR[3].rl = ret ;
     mres->FLGR.cr[0] &= ~0x10000000 ;
   }
   if( truss_stat==ON ) SYSMSG("===>%08x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 205: // _opendir()
   if( sc_emu_mode==LINUXPPC ){
     return(UNKNOWN_SYSCALL_NO) ;
   }else{
     ChkMemStr(mres,mres->GPR[3].rl,ret) ;
     if( ret!=0 ) return( MEM_ACCESS_FAULT ) ;
     if( truss_stat==ON ){
       SYSMSG("opendir(%08x,%08x)\n", mres->GPR[3].rl, mres->GPR[4].rl ) ;
     }
     {
       DIR *dirp ;
       
       DIR_exchg( mres, mres->GPR[4].rl ) ;
       dirp = opendir( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ) ;
       if( dirp==NULL ) mres->GPR[3].rl=0 ;
       else{
	 set_DIR_entry( mres->GPR[4].rl , dirp ) ;
	 mres->GPR[3].rl=mres->GPR[4].rl ; /** PPCdirpԂ **/
	 memcpy( &mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)], dirp, sizeof(DIR) ) ;
       }
       DIR_exchg( mres, mres->GPR[4].rl ) ;
       /*CygwinŃt@CGg(dirent̃Xg)ێĂ炵̂
	 dirpV~[^ɕێĂAclosedir()͎sĂ͂ȂȂ*/
     }
     mres->GPR[0].rl = errno ;
     mres->pc+=4 ; return(0) ;
   }
 case 206: // closedir()
   if( sc_emu_mode==LINUXPPC ){
     return(UNKNOWN_SYSCALL_NO) ;
   }else{
     if( truss_stat==ON ){
       SYSMSG("closedir(%08x)\n", mres->GPR[3].rl ) ;
     }
     {
       DIR *dirp ;
       dirp=search_DIR_entry( mres->GPR[3].rl ) ;
       if( dirp==NULL ){
	 SYSMSG("closedir() emulator internal error?.\n") ;
       }
       ret = closedir( dirp ) ;
       //SYSMSG("closedir ret = %x.\n", ret ) ;
       remove_DIR_entry( mres->GPR[3].rl ) ;
       mres->GPR[3].rl = ret ;
     }
     mres->GPR[0].rl = errno ;
     mres->pc+=4 ; return(0) ;
   }
 case 234: // exit_group()
   if( sc_emu_mode==LINUXPPC ){
     if( truss_stat==ON ) SYSMSG("group_exit(%x)\n",mres->GPR[3].rl) ;
     return(SYSCALLED_EXIT) ;
   }else{
     break ;
   }
 }
 
 return(UNKNOWN_SYSCALL_NO) ;

#else

 return(NOT_SUPPORT_SC_EMU) ;

#endif
}

void open_mode_exchg(int *mode1 , int *mode2 , struct MACHINE_RESOURCE *mres )
{
  /*
    open()̃tOւ
  */
  switch( sc_emu_mode ) {
  case LINUXPPC :
    {
      unsigned int new_mode=0 ;
      if( (mres->GPR[4].rl & 0x01 )!=0 ) new_mode |= O_WRONLY ;
      if( (mres->GPR[4].rl & 0x02 )!=0 ) new_mode |= O_RDWR   ;
      if( (mres->GPR[4].rl & 0x40 )!=0 ) new_mode |= O_CREAT  ;
      if( (mres->GPR[4].rl & 0x80 )!=0 ) new_mode |= O_EXCL   ;
      if( (mres->GPR[4].rl & 0x100)!=0 ) new_mode |= O_NOCTTY ;
      if( (mres->GPR[4].rl & 0x200)!=0 ) new_mode |= O_TRUNC  ;
      if( (mres->GPR[4].rl & 0x400)!=0 ) new_mode |= O_APPEND ;
      if( (mres->GPR[4].rl & 0x800)!=0 ) new_mode |= O_NONBLOCK ;
      *mode1 = new_mode | O_BINARY ; /*** force binary mode ***/
      *mode2 = mres->GPR[5].rl ;
    }
    break ;
  default : /* NEWLIBPPC */
    *mode1=mres->GPR[4].rl | O_BINARY ; /*** force binary mode ***/
    *mode2=mres->GPR[5].rl ;
  }
}

void stat_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  /*
    stat\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  
  SWAP2B(ptr[ 0]) ;/*stat->st_dev*/
  /*ptr[2],ptr[3]̓E߂̌*/
  SWAP4B(ptr[ 4]) ;/*stat->st_ino*/
  SWAP4B(ptr[ 8]) ;/*stat->st_mode*/
  SWAP2B(ptr[12]) ;/*stat->st_nlink*/
  SWAP2B(ptr[14]) ;/*stat->st_uid*/
  SWAP2B(ptr[16]) ;/*stat->st_gid*/
  SWAP2B(ptr[18]) ;/*stat->st_rdev*/
  SWAP4B(ptr[20]) ;/*stat->st_size*/
  SWAP4B(ptr[24]) ;/*stat->st_atime*/
  SWAP4B(ptr[28]) ;/*stat->st_spare1*/
  SWAP4B(ptr[32]) ;/*stat->st_mtime*/
  SWAP4B(ptr[36]) ;/*stat->st_spare2*/
  SWAP4B(ptr[40]) ;/*stat->st_ctime*/
  SWAP4B(ptr[44]) ;/*stat->st_spare3*/
  SWAP4B(ptr[48]) ;/*stat->st_blksize*/
  SWAP4B(ptr[52]) ;/*stat->st_blocks*/
  SWAP4B(ptr[56]) ;/*stat->st_spare4[0]*/
  SWAP4B(ptr[60]) ;/*stat->st_spare4[1]*/
}

void DIR_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  /*
    DIR\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  
  SWAP4B(ptr[ 0]) ;/*DIR->__d_cookie*/
  SWAP4B(ptr[ 4]) ;/*DIR->*__d_dirent*/
  SWAP4B(ptr[ 8]) ;/*DIR->*__d_dirname*/
  SWAP4B(ptr[12]) ;/*DIR->*__d_position*/
  SWAP4B(ptr[16]) ;/*DIR->__d_dirhash*/
  /*char^zȂ̂ősv*//*DIR->__d_u.__d_filler[16]*/
}

void dirent_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  /*
    dirent\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  
  SWAP4B(ptr[ 0]) ;/*dirent->__d_reserved[0]*/
  SWAP4B(ptr[ 4]) ;/*dirent->__d_reserved[1]*/
  SWAP4B(ptr[ 8]) ;/*dirent->__d_reserved[2]*/
  SWAP4B(ptr[12]) ;/*dirent->__d_reserved[3]*/
  SWAP4B(ptr[16]) ;/*dirent->__d_ino*/
  /*char^zȂ̂ősv*//*dirent->__d_u.__d_name[256]*/
}

void set_DIR_entry( unsigned int adrs , DIR *dirpt )
{
#ifdef SUPPORT_SYSTEMCALL_EMULATION
int i ;

 for( i=0 ; i<DIR_ENTRY_MAX ; i++ ){
   if( dir_list[i].ppc_mem_ptr==0 ){
     dir_list[i].ppc_mem_ptr=adrs ;
     dir_list[i].cygwin_DIR =dirpt ;
     break ;
   }
 }
#endif
}

void remove_DIR_entry( unsigned int adrs )
{
#ifdef SUPPORT_SYSTEMCALL_EMULATION
int i ;

 for( i=0 ; i<DIR_ENTRY_MAX ; i++ ){
   if( dir_list[i].ppc_mem_ptr==adrs ){
     dir_list[i].ppc_mem_ptr=0 ;
     dir_list[i].cygwin_DIR =NULL ;
     break ;
   }
 }
#endif
}

DIR* search_DIR_entry( unsigned int adrs )
{
#ifdef SUPPORT_SYSTEMCALL_EMULATION
int i ;

 for( i=0 ; i<DIR_ENTRY_MAX ; i++ ){
   if( dir_list[i].ppc_mem_ptr==adrs ){
     return(dir_list[i].cygwin_DIR) ;
   }
 }
 return(NULL) ;
#else
 return(NULL) ;
#endif
}

void timbuf_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  /*
    timbuf\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  
  SWAP4B(ptr[ 0]) ;/*timbuf->actime*/
  SWAP4B(ptr[ 4]) ;/*timbuf->modtime*/
}

void tm_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  /*
    tm\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  
  SWAP4B(ptr[ 0]) ;/*tm->tm_sec*/
  SWAP4B(ptr[ 4]) ;/*tm->tm_min*/
  SWAP4B(ptr[ 8]) ;/*tm->tm_hour*/
  SWAP4B(ptr[12]) ;/*tm->tm_mday*/
  SWAP4B(ptr[16]) ;/*tm->tm_mon*/
  SWAP4B(ptr[20]) ;/*tm->tm_year*/
  SWAP4B(ptr[24]) ;/*tm->tm_wday*/
  SWAP4B(ptr[28]) ;/*tm->tm_yday*/
  SWAP4B(ptr[32]) ;/*tm->tm_isdst*/
}

void timeval_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  /*
    timeval\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  
  SWAP4B(ptr[ 0]) ;/*timeval->tv_sec*/
  SWAP4B(ptr[ 4]) ;/*timevel->tv_usec*/
}

void timezone_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  /*
    timezone\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  
  SWAP4B(ptr[ 0]) ;/*timezone->tz_minuteswest*/
  SWAP4B(ptr[ 4]) ;/*timezone->tzdsttime*/
}


void stat_cpyto32( struct stat *st, struct MACHINE_RESOURCE *mres, unsigned int adrs )
{
  unsigned char *ptr ;
  /*
    stat\̃o[Rs[
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;

  if( sc_emu_mode==LINUXPPC ){
    *(int*  )(&ptr[ 0])=st->st_dev       ; SWAP4B(ptr[ 0]) ;
    *(int*  )(&ptr[ 4])=st->st_ino       ; SWAP4B(ptr[ 4]) ;
    *(int*  )(&ptr[ 8])=st->st_mode      ; SWAP4B(ptr[ 8]) ;
    *(int*  )(&ptr[12])=st->st_nlink     ; SWAP4B(ptr[12]) ;
    *(int*  )(&ptr[16])=st->st_uid       ; SWAP4B(ptr[16]) ;
    *(int*  )(&ptr[20])=st->st_gid       ; SWAP4B(ptr[20]) ;
    *(int*  )(&ptr[24])=st->st_rdev      ; SWAP4B(ptr[24]) ;
    *(int*  )(&ptr[28])=st->st_size      ; SWAP4B(ptr[28]) ;
    *(int*  )(&ptr[32])=st->st_blksize   ; SWAP4B(ptr[32]) ;
    *(int*  )(&ptr[36])=st->st_blocks    ; SWAP4B(ptr[36]) ;
    *(int*  )(&ptr[40])=st->st_atime     ; SWAP4B(ptr[40]) ;
    *(int*  )(&ptr[48])=st->st_mtime     ; SWAP4B(ptr[48]) ;
    *(int*  )(&ptr[56])=st->st_ctime     ; SWAP4B(ptr[56]) ;
  }else{
    *(short*)(&ptr[ 0])=st->st_dev       ; SWAP2B(ptr[ 0]) ;
    *(int*  )(&ptr[ 4])=st->st_ino       ; SWAP4B(ptr[ 4]) ;
    *(int*  )(&ptr[ 8])=st->st_mode      ; SWAP4B(ptr[ 8]) ;
    *(short*)(&ptr[12])=st->st_nlink     ; SWAP2B(ptr[12]) ;
    *(short*)(&ptr[14])=st->st_uid       ; SWAP2B(ptr[14]) ;
    *(short*)(&ptr[16])=st->st_gid       ; SWAP2B(ptr[16]) ;
    *(short*)(&ptr[18])=st->st_rdev      ; SWAP2B(ptr[18]) ;
    *(int*  )(&ptr[20])=st->st_size      ; SWAP4B(ptr[20]) ;
    *(int*  )(&ptr[24])=st->st_atime     ; SWAP4B(ptr[24]) ;
    //  *(int*  )(&ptr[28])=st->st_spare1    ; SWAP4B(ptr[28]) ;
    *(int*  )(&ptr[32])=st->st_mtime     ; SWAP4B(ptr[32]) ;
    //  *(int*  )(&ptr[36])=st->st_spare2    ; SWAP4B(ptr[36]) ;
    *(int*  )(&ptr[40])=st->st_ctime     ; SWAP4B(ptr[40]) ;
    //  *(int*  )(&ptr[44])=st->st_spare3    ; SWAP4B(ptr[44]) ;
    *(int*  )(&ptr[48])=st->st_blksize   ; SWAP4B(ptr[48]) ;
    *(int*  )(&ptr[52])=st->st_blocks    ; SWAP4B(ptr[52]) ;
    *(int*  )(&ptr[56])=st->st_spare4[0] ; SWAP4B(ptr[56]) ;
    *(int*  )(&ptr[60])=st->st_spare4[1] ; SWAP4B(ptr[60]) ;
  }
}


void stat_cpyto64( struct stat *st, struct MACHINE_RESOURCE *mres, unsigned int adrs )
{
  unsigned char *ptr ;
  /*
    stat\̃o[Rs[
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;

  *(long long*)(&ptr[ 0])=(long long)st->st_dev    ; SWAP8B(ptr[ 0]) ;
  *(long long*)(&ptr[ 8])=(long long)st->st_ino    ; SWAP8B(ptr[ 8]) ;
  *(int*      )(&ptr[16])=(int      )st->st_mode   ; SWAP4B(ptr[16]) ;
  *(int*      )(&ptr[20])=(int      )st->st_nlink  ; SWAP4B(ptr[20]) ;
  *(int*      )(&ptr[24])=(int      )st->st_uid    ; SWAP4B(ptr[24]) ;
  *(int*      )(&ptr[28])=(int      )st->st_gid    ; SWAP4B(ptr[28]) ;
  *(long long*)(&ptr[32])=(long long)st->st_rdev   ; SWAP8B(ptr[32]) ;
  
  *(long long*)(&ptr[48])=(long long)st->st_size   ; SWAP8B(ptr[48]) ;
  *(int*      )(&ptr[56])=(int      )st->st_blksize; SWAP4B(ptr[56]) ;
  *(long long*)(&ptr[64])=(long long)st->st_blocks ; SWAP8B(ptr[64]) ;
  *(int*      )(&ptr[72])=(int      )st->st_atime  ; SWAP4B(ptr[72]) ;

  *(int*      )(&ptr[80])=(int      )st->st_mtime  ; SWAP4B(ptr[80]) ;

  *(int*      )(&ptr[88])=(int      )st->st_ctime  ; SWAP4B(ptr[88]) ;
}

int set_phyfd( struct MACHINE_RESOURCE *mres, int fd )
{
  int i ;

  for( i=0 ; i<MAX_OPEN_FD ; i++ ){
    if( mres->openfd[i]==-1 ){
      mres->openfd[i]=fd ;
      return(i) ;
    }
  }
  
  return(-1) ;
}
  
int set_phyfd2( struct MACHINE_RESOURCE *mres, int fd, int pfd)
{
  if( fd<0 ) return(-1) ;
  close_fd(mres,fd) ;
  mres->openfd[fd]=pfd ;
  return(fd) ;
}
  
int get_phyfd( struct MACHINE_RESOURCE *mres, int fd )
{
  return( mres->openfd[fd] ) ;
}
  
int close_fd( struct MACHINE_RESOURCE *mres, int fd )
{
  int ret ;
  if( fd<0 || mres->openfd[fd]==-1 ) return(-1) ;
  ret=close(mres->openfd[fd]) ;
  mres->openfd[fd]=-1 ;
  return(ret) ;
}
  

/*****************************************************************************


  pathconf(),fpathconf()̎ɂāB
  newlibsysvi386ł͂̓VXeR[ƂĎĂB
  Linuxł(glibc琄) _statfs()VXeR[p pathconf
  ߂lւlȌ`ŎĂB
  libcX68kł͌ŒlԂlȃX^uŎB
  Cygwinł_statfs()gȂ̂ŁApathconf(),fpathconf()̓VXeR[
  ƂĒ`KvB

  readlink()
  Linuxł̓VXeR[ƂĒ`ĂB
  CygwinłVXeR[ƂĒ`ĂH
  libcX68kłsymlinkhCogpDOSR[ƂăG~[gB
*****************************************************************************/
