/**********************************************************************
  }VC[W̃t@CZ[uR}h
  $Id: save_cmd.c,v 1.4 2003/07/06 01:37:05 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int  save_parse_opt(struct GETOPT_ARG *args) ;
void save_print_help() ;

int save_cmd( struct GETOPT_ARG *args , int mode )
{
  int    begin,size ;
  int    id ; 
  FILE   *fp;
  int    ret ;
  
  ret=save_parse_opt(args) ;
  if( ret<0 ) return(NORMAL_EXIT) ;
  
  id=proc_list.cur_id ;
  
  if( XGETOPT_REFAGCP(args)<2 ){
    SYSMSG("Too few argument(s)\n") ;
    return(SPECIFY_ERROR) ;
  }
  
  switch( (XGETOPT_REFAGCP(args)-1) ){
  case 2: /** file begin **/
    begin=exatoi(XGETOPT_REFARGP(args,2)) ;
    size =proc_list.proc[id].mem_size[seg(begin)]-lad(begin) ;
    break ;
  case 3: /** file begin size **/
    begin=exatoi(XGETOPT_REFARGP(args,2)) ;
    size =exatoi(XGETOPT_REFARGP(args,3)) ;
    break ;
  default :
    begin=0 ;
    size =proc_list.proc[id].mem_size[seg(begin)] ;
  }
  if( lad(begin)>=proc_list.proc[id].mem_size[seg(begin)] ){
    SYSMSG("Start address is invalid(addr=%d).\n", begin ) ;
    return(SPECIFY_ERROR) ;
  }
  if( lad(begin)+size > proc_list.proc[id].mem_size[seg(begin)] ){
    size = size - (begin+size-proc_list.proc[id].mem_size[seg(begin)]) ;
  }
  if( verbose==ON ) SYSMSG("begin=%d size=%d\n",begin,size) ;
  
  if( ( fp = fopen( XGETOPT_REFARGP(args,1) , "wb" )) == NULL ){
    SYSMSG("Can not open file(%s)\n",XGETOPT_REFARGP(args,1)) ;
    return(FILE_OPEN_ERROR) ;
  }
  fwrite( &proc_list.proc[id].mem[seg(begin)][lad(begin)] , size , 1, fp ) ;
  
  fclose( fp ) ;
  return(NORMAL_EXIT) ;
}


int save_parse_opt(struct GETOPT_ARG *args)
{
  static struct GETOPT_LIST getopt_list[]={
    {"help",               'h',  NONARG, 'h'},
    { NULL,               '\0',       0,'\0'} /*** terminator ***/
  } ;
  int ret ;
  
  while(-1){
    ret=xgetopt(args, getopt_list) ;
    if( ret==XGETOPT_PARSE_COMPLETE ) break ;
    switch(ret){
    case 'h' :
      save_print_help() ;
      return(-1) ;
      break ;
    case XGETOPT_INVALID_OPTION :
      SYSERR("Invalid option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_ARG_NOT_FOUND :
      SYSERR("Illegal arg for option %s\n",xgetopt_err) ;
      return(-1) ;
      break ;
    case XGETOPT_NOT_OPTION :
      break ;
    default :
      SYSERR("xgetopt internal error\n") ;
      return(-1) ;
    }
  }
  return(0) ;
}


void save_print_help()
{
  SYSERR(
	 "Save file to memory\n"
	 "Usage: save [Options] file [adrs [size]]\n"
	 " Options\n"
	 "  -h or --help : Print this help.\n"
	 "\n"
	 "      V~[^̃f[^t@CɃZ[u܂BZ[uJnԒn\n"
	 "     ȗꍇ 0x00000000ԒnJnԒnɂȂ܂BZ[uTCYȗ\n"
	 "     ꍇ̓V~[^̍ŏʃAhX܂ŃZ[u܂B\n"
	 ) ;
}
